package org.rhq.sample.resourcefactory;

import java.util.HashSet;
import java.util.Map;
import java.util.Properties;
import java.util.Set;

import org.rhq.core.domain.configuration.Configuration;
import org.rhq.core.domain.configuration.PropertySimple;
import org.rhq.core.pluginapi.inventory.DiscoveredResourceDetails;
import org.rhq.core.pluginapi.inventory.InvalidPluginConfigurationException;
import org.rhq.core.pluginapi.inventory.ManualAddFacet;
import org.rhq.core.pluginapi.inventory.ResourceDiscoveryComponent;
import org.rhq.core.pluginapi.inventory.ResourceDiscoveryContext;

public class ChildDiscoveryComponent implements ResourceDiscoveryComponent<SamplePluginServerComponent>,
    ManualAddFacet<ChildServerComponent> {
    public DiscoveredResourceDetails discoverResource(Configuration pluginConfiguration,
        ResourceDiscoveryContext<ChildServerComponent> context) throws InvalidPluginConfigurationException {
        String key = pluginConfiguration.getSimpleValue("key", String.valueOf(System.currentTimeMillis()));
        String name = "My Child";
        String version = "1.0";
        String description = "This is My Child";

        DiscoveredResourceDetails resource = new DiscoveredResourceDetails(context.getResourceType(), key, name,
            version, description, pluginConfiguration, null);

        return resource;
    }

    public Set<DiscoveredResourceDetails> discoverResources(
        ResourceDiscoveryContext<SamplePluginServerComponent> context) {

        // we "auto-discover" by reading our children properties file and create one child per property
        Properties props = context.getParentResourceComponent().readChildrenProperties();
        HashSet<DiscoveredResourceDetails> set = new HashSet<DiscoveredResourceDetails>();
        for (Map.Entry<Object, Object> keyName : props.entrySet()) {
            Configuration pluginConfiguration = new Configuration();
            pluginConfiguration.put(new PropertySimple("key", keyName.getKey().toString()));
            String key = keyName.getKey().toString();
            String name = keyName.getValue().toString();
            String version = "1.0";
            String description = "This is My Child";

            DiscoveredResourceDetails resource = new DiscoveredResourceDetails(context.getResourceType(), key, name,
                version, description, null, null);
            set.add(resource);
        }
        return set;
    }
}
