package org.rhq.sample.resourcefactory;

import java.util.Properties;

import org.rhq.core.domain.measurement.AvailabilityType;
import org.rhq.core.pluginapi.inventory.DeleteResourceFacet;
import org.rhq.core.pluginapi.inventory.ResourceComponent;
import org.rhq.core.pluginapi.inventory.ResourceContext;

public class ChildServerComponent implements ResourceComponent<SamplePluginServerComponent>, DeleteResourceFacet {
    private ResourceContext<SamplePluginServerComponent> context;

    @Override
    public void start(ResourceContext<SamplePluginServerComponent> context) {
        this.context = context;
    }

    @Override
    public void stop() {
    }

    @Override
    public AvailabilityType getAvailability() {
        return AvailabilityType.UP;
    }

    @Override
    public void deleteResource() throws Exception {
        String doomedKey = context.getResourceKey();
        SamplePluginServerComponent parent = context.getParentResourceComponent();
        Properties props = parent.readChildrenProperties();
        props.remove(doomedKey);
        parent.writeChildrenProperties(props);
    }
}
